#ifndef _H_LETTERS
#define _H_LETTERS

#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <map>

class Letters{
private:

public:
	std::vector<std::string> sopa;
	std::vector<std::string> palavras;
	std::vector<std::pair< std::string, std::pair< std::pair<int, int>, std::pair<int, int> > > > RESULTADOS;
	int R,C;

	void READ(std::istream& input)
	{
		input >> R >> C;
		for(int i=0; i<R; i++)
		{
			std::string x;
			input >> x;
			sopa.push_back(x);
		}
		int N;
		input >> N;
		for(int i=0; i<N; i++)
		{
			std::string x;
			input >> x;
			palavras.push_back(x);
		}
	}

	void GetWord()
	{
		for(int i=0; i<static_cast<int>(palavras.size()); i++)
		{
			Get(palavras[i]);
		}
	}

	void Get(std::string w)
	{
		for(int y=0; y<R; y++)
		{
			for(int x=0; x<C; x++)
			{
				if(sopa[y][x] == w[0])
				{
					FindWord(w, x, y);
				}
			}
		}
	}

	bool Find(std::string w, int x, int y, int i, int j)
	{
		if( w== "")
			return true;
		else
		{
			if( x<0 || x>=C || y<0 || y>=R )
				return false;
			else
			{
				if(sopa[y][x] != w[0])
					return false;
				else
					return Find(w.substr(1, w.size()-1), x+i, y+j, i, j);
			}
		}
	}

	void SaveResult(std::string w, int x, int y, int i, int j)
	{
		RESULTADOS.push_back(std::make_pair(w, std::make_pair(std::make_pair(x, y), std::make_pair(x+i*(static_cast<int>(w.size()-1)),y+j*(static_cast<int>(w.size()-1))))));
	}

	void FindWord(std::string w, int x, int y)
	{
		for(int i=-1; i<=1; i++)
		{
			for(int j=-1; j<=1; j++)
			{
				if(!(i==0 && j==0))
				{
					if(Find(w.substr(1, w.size()-1), x+i, y+j, i, j))
					{
						SaveResult(w, x, y, i, j);
					}
				}
			}
		}
	}

	void WriteVector()
	{
		if(RESULTADOS.size() != 0)
		{
			std::sort(RESULTADOS.begin(), RESULTADOS.end());
			for(int i=0; i<static_cast<int>(RESULTADOS.size()); i++)
			{
				std::cout << RESULTADOS[i].first;
				std::cout << " " << RESULTADOS[i].second.first.first;
				std::cout << " " << RESULTADOS[i].second.first.second;
				std::cout << " " << RESULTADOS[i].second.second.first;
				std::cout << " " << RESULTADOS[i].second.second.second << std::endl;
			}
		}
		else
			std::cout << "NO" << std::endl;
	}
};

#endif
